/// @cond EO_CXX_EO_IMPL

inline Elm_Bg_Option elm::bg::option_get() const
{
   Elm_Bg_Option _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_bg_option_get());
   return _tmp_ret;
}

inline void elm::bg::option_set(Elm_Bg_Option option_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_bg_option_set(option_));
}

inline void elm::bg::color_get(int* r_, int* g_, int* b_, int* a_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_bg_color_get(r_, g_, b_, a_));
}

inline void elm::bg::color_set(int r_, int g_, int b_, int a_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_bg_color_set(r_, g_, b_, a_));
}

inline void elm::bg::load_size_set(Evas_Coord w_, Evas_Coord h_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_bg_load_size_set(w_, h_));
}

inline Elm_Bg_Option eo_cxx::elm::bg::option_get() const
{
   Elm_Bg_Option _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_bg_option_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::bg::option_set(Elm_Bg_Option option_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_bg_option_set(option_));
}

inline void eo_cxx::elm::bg::color_get(int* r_, int* g_, int* b_, int* a_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_bg_color_get(r_, g_, b_, a_));
}

inline void eo_cxx::elm::bg::color_set(int r_, int g_, int b_, int a_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_bg_color_set(r_, g_, b_, a_));
}

inline void eo_cxx::elm::bg::load_size_set(Evas_Coord w_, Evas_Coord h_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_bg_load_size_set(w_, h_));
}

inline ::eo_cxx::elm::bg::operator ::elm::bg() const
{
   return *static_cast<::elm::bg const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm::bg::operator ::elm::bg&()
{
   return *static_cast<::elm::bg*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm::bg::operator ::elm::bg const&() const
{
   return *static_cast<::elm::bg const*>(static_cast<void const*>(this));
}

template <typename T>
Elm_Bg_Option elm_bg_option_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->option_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Bg_Option _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_bg_option_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Bg_Option option_)
{
   try
      {
         static_cast<T*>(self->this_)->option_set(option_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_bg_color_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int* r_, int* g_, int* b_, int* a_)
{
   try
      {
         static_cast<T*>(self->this_)->color_get(r_, g_, b_, a_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_bg_color_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int r_, int g_, int b_, int a_)
{
   try
      {
         static_cast<T*>(self->this_)->color_set(r_, g_, b_, a_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_bg_load_size_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Coord w_, Evas_Coord h_)
{
   try
      {
         static_cast<T*>(self->this_)->load_size_set(w_, h_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm::bg >
{
   template <typename T>
   struct type
         : virtual operations< ::elm::layout >::template type<T>
         , virtual operations< ::efl::file >::template type<T>
   {
      virtual Elm_Bg_Option option_get()
      {
         Elm_Bg_Option _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_bg_option_get());
            return _tmp_ret;
      }

      virtual void option_set(Elm_Bg_Option option_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_bg_option_set(option_));
      }

      virtual void color_get(int* r_, int* g_, int* b_, int* a_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_bg_color_get(r_, g_, b_, a_));
      }

      virtual void color_set(int r_, int g_, int b_, int a_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_bg_color_set(r_, g_, b_, a_));
      }

      virtual void load_size_set(Evas_Coord w_, Evas_Coord h_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_bg_load_size_set(w_, h_));
      }

   };
};


template<>
struct operation_description_class_size< ::elm::bg >
{
   static constexpr int value = 
#if defined(BG_PROTECTED) && defined(BG_BETA)
      5
#elif defined(BG_PROTECTED)
      5
#elif defined(BG_BETA)
      5
#else
      5
#endif
      + operation_description_class_size<::elm::layout >::value      + operation_description_class_size<::efl::file >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm::bg>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::elm_bg_option_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_bg_option_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_bg_option_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_bg_option_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_bg_color_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_bg_color_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_bg_color_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_bg_color_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_bg_load_size_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_bg_load_size_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::elm::layout>(), &ops[operation_description_class_size< ::elm::bg >::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::efl::file>(), &ops[operation_description_class_size< ::elm::bg >::value + operation_description_class_size<::elm::layout>::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm::bg>)
{
   return (ELM_BG_CLASS);
}

} } }

/// @endcond

